function [C, SINR, G, PL, numOfWalls, dist, isIndoor] = CapacityFemto_C(var1, var2, var3, var4)
nargchk(2, 4, nargin);
if nargin == 2
    [C, SINR, G, PL, numOfWalls, dist, isIndoor] = CapacityFemto_C1(var1, var2);
else
    [C, SINR, G, PL, numOfWalls, dist, isIndoor] = CapacityFemto_C2(var1, var2, var3, var4);
end


function [C, SINR, G, PL, numOfWalls, dist, isIndoor] = CapacityFemto_C1(userID, handles)
coordVectors = get(handles.figure1, 'UserData');
cellID = coordVectors.att_cell(userID);
[C, SINR, G, PL, numOfWalls, dist, isIndoor] = CapacityFemto_C2(coordVectors.fuser_x(userID), coordVectors.fuser_y(userID), cellID, handles);


function [C, SINR, G, PL, numOfWalls, dist, isIndoor] = CapacityFemto_C2(x, y, cellID, handles)
awgn_N0 = 1;
spacing_Df = 15 * 10^3;
BER = 10^(-6);
alpha = -1.5 / log(5 * BER);
subcarriersPerResBlock = 12;

mode_selection = get(handles.popupmenu6, 'Value');
macro_fr_mode = get(handles.popupmenu9,'Value');
femto_fr_mode = get(handles.popupmenu10,'Value');
coordVectors = get(handles.figure1, 'UserData');

numOfFemtousers = histc(coordVectors.att_cell, cellID);
if (get(handles.popupmenu7, 'Value') ==  cellID + 2)
    numOfFemtousers = numOfFemtousers + 1;
end
if mode_selection <= 3
    resBlocks = 100;
elseif mode_selection <= 6
    resBlocks = 75;
elseif mode_selection <= 9
    resBlocks = 50;
elseif mode_selection <= 12
    resBlocks = 25;
elseif mode_selection <= 15
    resBlocks = 15;
else
    resBlocks = 6;
end

if mod(mode_selection, 3) == 0
    bitsPerSymbol = 2;
elseif mod(mode_selection, 3) == 1
    bitsPerSymbol = 4;
else
    bitsPerSymbol = 6;
end

if femto_fr_mode == 2 || femto_fr_mode == 3 %Macro ffr
    if macro_fr_mode == 2 
        partition_coeff_macro = 2/3;
    elseif macro_fr_mode == 3
        partition_coeff_macro = 3/4;
    elseif macro_fr_mode == 4
        if coordVectors.femtocellIsInner(cellID)== 1 
            partition_coeff_macro = 1/3;
        else
            partition_coeff_macro = 2/3;
        end
    end
else
    partition_coeff_macro = 1;
end

if femto_fr_mode == 3 || femto_fr_mode == 4
    partition_coeff_femto = 1/6;
else
    partition_coeff_femto = 1;
end

    

subcarriersPerUser = subcarriersPerResBlock * resBlocks / numOfFemtousers;
[SINR, G, PL, numOfWalls, dist, isIndoor] = SINRfemto(x, y, cellID, handles);

C_temp = (partition_coeff_macro * partition_coeff_femto * subcarriersPerUser * bitsPerSymbol * spacing_Df) * log2(1 + alpha * SINR);
coordVectors = get(handles.figure1, 'UserData');
inside_of_cell_bounds = coordVectors.inside_of_cell_bounds;
C = inside_of_cell_bounds.*C_temp;