function [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRfemto(var1, var2, var3, var4)
nargchk(2, 4, nargin);
if nargin == 2
    [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRfemto1(var1, var2);
else
    [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRfemto2(var1, var2, var3, var4);
end


function [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRfemto1(userID, handles)
coordVectors = get(handles.figure1, 'UserData');
cellID = coordVectors.att_cell(userID);
[SINR, G, PL, numOfWalls, dist, isIndoor] = SINRfemto2(coordVectors.fuser_x(userID), coordVectors.fuser_y(userID), cellID, handles);


function [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRfemto2(x, y, cellID, handles)
PSD_dBm = -174; %dBm/Hz
awgn_N0 = (10^(PSD_dBm / 10)) / 1000;
spacing_Df = 15*10^3;
[row col] = size(x);
upper_thres = ones(row, col)*(100);

coordVectors = get(handles.figure1, 'UserData');
femto_fr_mode = get(handles.popupmenu10,'Value');
macro_fr_mode = get(handles.popupmenu9,'Value');

numOfFemtocells = min(size(coordVectors.femt_x, 2), size(coordVectors.femt_y, 2));
numOfMacrocells = 1;

st = dbstack;

if coordVectors.gain_calculated_f(cellID) == 0 || coordVectors.gain_calculated_f(cellID) == 1 || coordVectors.gain_calculated_f(cellID) == 3  || strcmp(st(3).file,'findRangeSINR.m')
    [G, PL, numOfWalls, dist, isIndoor] = Gain_femto(x, y, coordVectors.femt_x(cellID), coordVectors.femt_y(cellID), handles);
    if (~strcmp(st(3).file,'findRangeSINR.m'))
        coordVectors = get(handles.figure1, 'UserData');
        coordVectors.(genvarname(num2str(cellID))) = G;
        coordVectors.(genvarname(num2str(cellID+numOfFemtocells))) = PL;
        coordVectors.(genvarname(num2str(cellID+ 2*numOfFemtocells))) = numOfWalls;
        coordVectors.(genvarname(num2str(cellID+ 3*numOfFemtocells))) = dist;
        coordVectors.(genvarname(num2str(cellID+ 4*numOfFemtocells))) = isIndoor;
        
    
        coordVectors.gain_calculated_f(cellID) = 2;
        set(handles.figure1, 'UserData', coordVectors);
    end
else
    
    G = coordVectors.(genvarname(num2str(cellID)));
    PL = coordVectors.(genvarname(num2str(cellID+numOfFemtocells)));
    numOfWalls = coordVectors.(genvarname(num2str(cellID+ 2*numOfFemtocells)));
    dist = coordVectors.(genvarname(num2str(cellID+ 3*numOfFemtocells)));
    isIndoor = coordVectors.(genvarname(num2str(cellID+ 4*numOfFemtocells)));
end

if strcmp(st(3).file,'findRangeSINR.m')
    Pfemto = coordVectors.powFemto;
    Pmacro_dbm = str2num(get(handles.edit6,'String'));
    Pmacro = (10^(Pmacro_dbm / 10)) / 1000;
else
    [Pmacro Pfemto] = power_scheme(handles);
end

numer = Pfemto(cellID) * G;

sum1 = zeros(row,col);
sum2 = zeros(row,col);

coordVectors = get(handles.figure1, 'UserData');
for i=1:numOfFemtocells
    if i ~= cellID
        if coordVectors.gain_calculated_f(i) == 0 || coordVectors.gain_calculated_f(i) == 3 || strcmp(st(3).file,'findRangeSINR.m')
            G_f = Gain_femto(x, y, coordVectors.femt_x(i), coordVectors.femt_y(i), handles);
            if (~strcmp(st(3).file,'findRangeSINR.m'))
                coordVectors = get(handles.figure1, 'UserData');
                  coordVectors.(genvarname(num2str(i))) = G_f;
                  coordVectors.gain_calculated_f(i)=1;
                  set(handles.figure1, 'UserData', coordVectors);
            end
        else
            G_f = coordVectors.(genvarname(num2str(i)));
        end
        
        if femto_fr_mode == 3 || femto_fr_mode == 4
            sum1 = sum1 + 0;
        else
            sum1 = sum1 + Pfemto(i) * G_f;
        end
        
        
    end
end

for i=1:numOfMacrocells
    if coordVectors.gain_calculated_m == 0 || strcmp(st(3).file,'findRangeSINR.m')
        G_m = Gain_macro(x, y, 250.0, 217.0, handles);
        if (~strcmp(st(3).file,'findRangeSINR.m'))
                    coordVectors = get(handles.figure1, 'UserData');
                    coordVectors.Gain_m = G_m;
                    coordVectors.gain_calculated_m = 1;
                    set(handles.figure1, 'UserData', coordVectors);
        end
    else
        G_m = coordVectors.Gain_m;
    end
    
    sumall = sum(sum(Pmacro * G_m))
    if femto_fr_mode == 2 ||femto_fr_mode == 3
        sum2 = sum2 + 0;
    else
        sum2 = sum2 + Pmacro * G_m;
    end
        %sum2 = sum2 + Pmacro * G_m;
end


sum2 = interference_calc_macro(x, y, sum2, Pmacro, handles, 2);


denom = awgn_N0 * spacing_Df + sum1 + sum2;
temp = numer./denom;
if strcmp(st(3).file,'findRangeSINR.m')
    SINR = temp;
else
    SINR = min(temp, upper_thres);
end
%coordVectors = get(handles.figure1, 'UserData');
%coordVectors.SINR = SINR;