function [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro(var1, var2, var3, var4)
nargchk(2, 4, nargin);
if nargin == 2
    [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro1(var1, var2);
else
    [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro2(var1, var2, var3, var4);
end


function [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro1(userID, handles)
coordVectors = get(handles.figure1, 'UserData');
cellID = 1;
[SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro2(coordVectors.muser_x(userID), coordVectors.muser_y(userID), cellID, handles);


function [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRmacro2(x, y, cellID, handles)
PSD_dBm = -174; %dBm/Hz
awgn_N0 = (10^(PSD_dBm / 10)) / 1000;
spacing_Df = 15*10^3;
[row col] = size(x);
%upper_thres = ones(row, col)*(-log(5*10^(-6))/1.5);
upper_thres = ones(row, col)*55;

coordVectors = get(handles.figure1, 'UserData');

numOfFemtocells = min(size(coordVectors.femt_x, 2), size(coordVectors.femt_y, 2));
numOfMacrocells = 1;


if coordVectors.gain_calculated_m == 0
    [G, PL, numOfWalls, dist, isIndoor] = Gain_macro(x, y, 250.0, 217.0, handles);
    coordVectors = get(handles.figure1, 'UserData');
    coordVectors.Gain_m = G;
    coordVectors.PathLoss_m = PL;
    coordVectors.Walls_m = numOfWalls;
    coordVectors.distance_m = dist;
    coordVectors.isIn_m = isIndoor;
    
    coordVectors.gain_calculated_m = 1;
    set(handles.figure1, 'UserData', coordVectors);
else
    G = coordVectors.Gain_m;
    PL = coordVectors.PathLoss_m;
    numOfWalls = coordVectors.Walls_m;
    dist = coordVectors.distance_m;
    isIndoor = coordVectors.isIn_m;
end

[Pmacro Pfemto] = power_scheme(handles);

numer = Pmacro * G;

sum1 = zeros(row,col);
sum2 = zeros(row,col);
coordVectors = get(handles.figure1, 'UserData');
dist_from_centre = coordVectors.dist_from_centre;
inner_point = coordVectors.inner_point;

for i=1:numOfFemtocells
    if coordVectors.gain_calculated_f(i) == 0
        G_f = Gain_femto(x, y, coordVectors.femt_x(i), coordVectors.femt_y(i), handles);
        coordVectors = get(handles.figure1, 'UserData');
        coordVectors.(genvarname(num2str(i+numOfFemtocells*5))) = G_f;
        coordVectors.gain_calculated_f(i) = 3;
        set(handles.figure1, 'UserData', coordVectors);
    else
        G_f = coordVectors.(genvarname(num2str(i+numOfFemtocells*5)));
    end
    
    sum1 = interference_calc(sum1, Pfemto(i), i, G_f, handles);
    
%     if (get(handles.popupmenu9,'Value') == 1)   %none
%         sum1 = sum1 + Pfemto(i) * G_f;
%     elseif (get(handles.popupmenu9,'Value') == 2)   %IFR
%         if (get(handles.popupmenu10,'Value') == 1)
%             sum1 = sum1 + Pfemto(i) * G_f;
%         else
%             sum1 = zeros(row,col);
%         end
%     elseif (get(handles.popupmenu9,'Value') == 3)   %FFR
%         if (get(handles.popupmenu10,'Value') == 1)
%             sum1 = sum1 + Pfemto(i) * G_f;
%         else
%             if coordVectors.femtocellIsInner(i)== 1 
%                 temp1 = Pfemto(i) * G_f;
%                 temp2 = (abs(inner_point-0.5)).*temp1;
%                 sum1 = sum1 + temp2;
%             else
%                 temp1 = Pfemto(i) * G_f;
%                 temp2 = (inner_point+0.5).*temp1;
%                 sum1 = sum1 + temp2;
%             end
%         end
%     elseif (get(handles.popupmenu9,'Value') == 4)   %SFR
%         if (get(handles.popupmenu10,'Value') == 1)
%             sum1 = sum1 + Pfemto(i) * G_f;
%         else
%             if coordVectors.femtocellIsInner(i)== 1 
%                 temp1 = Pfemto(i) * G_f;
%                 temp2 = (abs(inner_point-0.5)).*temp1;
%                 sum1 = sum1 + temp2;
%             else
%                 temp1 = Pfemto(i) * G_f;
%                 temp2 = (inner_point+0.5).*temp1;
%                 sum1 = sum1 + temp2;
%             end
%         end
%     end
end

sum2 = interference_calc_macro(x, y,sum2, Pmacro, handles, 1);

% numOfWalls_neigh = zeros(row/2,col/2);
% penLoss_Low = str2num(get(handles.edit14,'String'));
% building_x = get(handles.Slider1,'Value');
% building_y = get(handles.Slider2,'Value');
% 
% numOfWalls_neigh = numOfWalls(1:row/2,1:col/2) + max(building_x, building_y);
% 
% R = calcDist(x_user, y_user, x_macrocell, y_macrocell);
% PL = log10((10^15.3 * (R.^37.6)).* (10.^(penLoss_Low * numOfWalls)));
% 
% gain_macro_neigh_part2 = fliplr(gain_macro_neigh_part1);
% gain_macro_neigh_part3 = flipud(gain_macro_neigh_part1);
% gain_macro_neigh_part4 = flipud(gain_macro_neigh_part2);
% 
% gain_macro_neigh_all = [gain_macro_neigh_part1 gain_macro_neigh_part2;gain_macro_neigh_part3 gain_macro_neigh_part4];

denom = awgn_N0 * spacing_Df + sum1 + sum2;
%  if (get(handles.popupmenu9,'Value') == 2)
%           denom = awgn_N0 * spacing_Df + sum2; %ifr
%  elseif (get(handles.popupmenu9,'Value') == 3)%ffr
%      if dist_from_centre(l,k) > radius_fr-30
%           denom = awgn_N0 * spacing_Df + sum2;
%      else
%           denom = awgn_N0 * spacing_Df + sum2;
%      end
% elseif (get(handles.popupmenu9,'Value') == 4)%sfr
%      if dist_from_centre(l,k) > (radius_fr-30)
%           subscribers_partition(l,k) = 1/3;
%      else
%           subscribers_partition(l,k) = 2/3;
%      end
%end
temp = numer./denom;
%SINR = 10*log10(temp);
%SINR = max(SINR, (zeros(row,col)));
SINR = min(temp, upper_thres);
%SINR = temp;
coordVectors = get(handles.figure1, 'UserData');
coordVectors.SINR = SINR;
set(handles.figure1, 'UserData', coordVectors);