function drawColormap(handles)
set(handles.pushbutton8, 'Enable', 'off');
set(handles.popupmenu7, 'Enable', 'off');
set(handles.popupmenu6, 'Enable', 'off');
max_x = 250;
max_y = double(uint16(sqrt(3)*125));

x_samples = (max_x * 2)/4 + 1;
y_samples = (max_y * 2)/4 + 1;

throughput_Matrix = zeros(y_samples, x_samples);

attachedTo = get(handles.popupmenu7, 'Value');
waitbarMsg = 'Simulating... It will take a lot of time.';


if (get(handles.popupmenu8,'Value') == 1 || get(handles.popupmenu8,'Value') == 2)
    iteration = 1;
else
    iteration = 5; 
end

coordVectors = get(handles.figure1, 'UserData');
numOfFemtocells = min(size(coordVectors.femt_x, 2), size(coordVectors.femt_y, 2));
pow_default = str2num(get(handles.edit10,'String'));
coordVectors.powFemto = (ones(1, numOfFemtocells))*(10^(pow_default / 10)) / 1000;
coordVectors.iteration = iteration;
coordVectors.it = 1;
coordVectors.phase = 0;
coordVectors.interf_iterat = 0;
set(handles.figure1, 'UserData', coordVectors);

coordX_Matrix_t = ones(1,x_samples);
ind = find(coordX_Matrix_t)-1;
coordX_Matrix_t = ((max_x * 2.0) / x_samples)*ind;
coordX_Matrix = repmat(coordX_Matrix_t,y_samples,1);
coordY_Matrix_t = ones(y_samples,1);
ind2 = find(coordY_Matrix_t)-1;
coordY_Matrix_t = ((max_y * 2.0) / y_samples)*ind2;
coordY_Matrix = repmat(coordY_Matrix_t,1,x_samples);

coordVectors = get(handles.figure1, 'UserData');    
it=coordVectors.it;

while it <= iteration
    hold on;

    coordVectors = get(handles.figure1, 'UserData');
    coordVectors.it = it;
    set(handles.figure1, 'UserData', coordVectors);

    if attachedTo <= 1
        return;
    elseif attachedTo == 2
        deplID = attachedTo - 1;
        [throughput_Matrix, SINR, G, PL, numOfWalls, dist, isIndoor] = CapacityMacro_C(coordX_Matrix, coordY_Matrix, deplID, handles);
    else
        deplID = attachedTo - 2;


        [throughput_Matrix, SINR, G, PL, numOfWalls, dist, isIndoor] = CapacityFemto_C(coordX_Matrix, coordY_Matrix, deplID, handles);
    end


    if it>1
        resetMap(handles);
        set(handles.popupmenu6, 'Enable', 'off');
        set(handles.popupmenu7, 'Enable', 'off');
    end
    
    set(handles.popupmenu7, 'Enable', 'on');
    
    filename = 'matrix_limits.mat';
    load(filename, 'inside_of_cell_bounds');
    load(filename, 'outer_point');
    load(filename, 'multiplier');

    throughput_Matrix = throughput_Matrix.*inside_of_cell_bounds;
    total_throu = sum(sum(throughput_Matrix))
    coordVectors = get(handles.figure1, 'UserData');
    %outer_point = -(coordVectors.inner_point - 0.5);
    %inside_of_cell_bounds = coordVectors.inside_of_cell_bounds;
    %multiplier = inside_of_cell_bounds.*outer_point;
    throughput_Matrix_outer = throughput_Matrix.*(multiplier);
    SINR_edge = SINR.*(multiplier);
    total_outer_throu = sum(sum(throughput_Matrix_outer))
    
    to_th_res = reshape(throughput_Matrix,1,13734);
    sinr_res = reshape(SINR_edge,1,13734);
    
    hold on;
    contourLevels = 128;

    OPENGL SOFTWARE;
    set(gcf, 'Renderer', 'OpenGL');
    [c, h] = contourf([0:4:(max_x*2)], [0:4:(max_y*2)], throughput_Matrix, contourLevels);
    colormap(jet(128));
    alphable = findobj(h, '-property', 'FaceAlpha');
    set(h, 'EdgeColor', 'None');
    set(alphable, 'FaceAlpha', 0.3);
    set(handles.text15, 'String','Click map, for details.');
    set(handles.text15, 'Visible', 'on');
    coordVectors = get(handles.figure1, 'UserData');
    
    axis tight;
    colorbar;
    aformi = 0;
    while 1
        
        if (get(handles.popupmenu8,'Value') == 3) && (coordVectors.it<5)
            set(handles.text15, 'FontSize', 9);  
            set(handles.text15, 'String','Click map for details or elsewhere for next iteration.');
            set(handles.text15, 'Visible', 'on');
        end
        while 1
          k = waitforbuttonpress;
          if k == 0
             break;
          end
        end
    
    
    
        hold on;
    
        [x_real, y_real] = mouse_clicked(handles);
        if inMacrocellRange(x_real, y_real) == 1
            set(handles.text15, 'String','Please, wait...');
            set(handles.text15, 'Visible', 'on');
            x_new = incrValueX(x_real, max_x);
            y_new = incrValueY(y_real, max_y);
            x_matrix= round(x_new/4);
            y_matrix= round(y_new/4);
            if attachedTo == 2
                user_type = 'Macro user';
            else
                user_type = 'Femto user';
            end
        
            setPanel(handles, user_type, isIndoor, throughput_Matrix(y_matrix,x_matrix), ...
            SINR(y_matrix,x_matrix), PL(y_matrix,x_matrix), dist);         
        elseif (get(handles.popupmenu8,'Value') == 3) && (coordVectors.it<5)
            break;
        end
        set(handles.text15, 'FontSize', 12.4);
        set(handles.text15, 'String','Click map, for details.');
        set(handles.text15, 'Visible', 'on');
        
    end


    coordVectors = get(handles.figure1, 'UserData');    
    it=coordVectors.it;
    
end

