function currentSINR = findRangeSINR(handles)

R = str2num(get(handles.edit11,'String'));
coordVectors = get(handles.figure1, 'UserData');

numOfFemtocells = min(size(coordVectors.femt_x, 2), size(coordVectors.femt_y, 2));
currentSINR=zeros(1,numOfFemtocells);

for i=1:numOfFemtocells
    x1 = coordVectors.femt_x(i);
    y1 = coordVectors.femt_y(i);
    
    x = [x1 x1 max(x1-R,0) min(x1+R,496)];
    y = [min(y1+R,428) max(y1-R,0) y1 y1];
    [SINR, G, PL, numOfWalls, dist, isIndoor] = SINRfemto(x, y, i, handles);
    
    if histc(coordVectors.att_cell, i)==0
        NoF=1;
    else
        NoF = histc(coordVectors.att_cell, i);
    end
    currentSINR(i) = min(SINR)/NoF;
end