function [numOfWalls, isIndoor] = findWalls(x1, y1, x2, y2, handles)
[row col] = size(x1);
[row2 col2] = size(y1);
numOfWalls = zeros(row2, col);
radius_fr = get(handles.edit15,'Value');
isIndoor = zeros(length(x1) ,length(y1));
coordVectors = get(handles.figure1, 'UserData');


st1 = dbstack;

if strcmp(st1(2).file,'PLmac.m')
    subscribers_partition_macro = ones(row2, col);
    inside_of_cell_bounds = ones(row2, col);
end
if strcmp(st1(2).file,'PLfem.m')
    subscribers_partition_femto = ones(row2, col);
end
if (strcmp(st1(6).file,'findRangeSINR.m'))
    waitbarMsg = 'Simulating... ';
elseif (coordVectors.phase == 0)
    waitbarMsg = 'Calculating Path Loss... It will take a lot of time.';
else
    numOfFemtocells = min(size(coordVectors.femt_x, 2), size(coordVectors.femt_y, 2));
    num_Total = numOfFemtocells;
    stage = coordVectors.interf_iterat + 1;
    coordVectors.interf_iterat = stage;
    set(handles.figure1, 'UserData', coordVectors);
    str1 = num2str(stage);
    str2 = num2str(num_Total);
    str = horzcat('Calculating Interference...', str1 ,'/',str2, '. It will take a lot of time.');
    waitbarMsg = str;
    if stage == num_Total
        coordVectors = get(handles.figure1, 'UserData');
        coordVectors.interf_iterat = 0;
        set(handles.figure1, 'UserData', coordVectors);
    end
end
waitbar_h = waitbar(0, waitbarMsg);

for i=1:size(coordVectors.building, 2)
%      waitbar(i /((size(coordVectors.building, 2))*row2*col));
   buildCoords = coordVectors.building{i};
   xlimit = [buildCoords(1) (buildCoords(1)+buildCoords(3))];
   ylimit = [buildCoords(2) (buildCoords(2)+buildCoords(4))];
   if isIndoor == 0
%       if (xlimit(1) <= x1 && xlimit(2) >= x1 && ylimit(1) <= y1 && ylimit(2) >= y1)
%          isIndoor = 1;
%       end
        isIndoor = double(xlimit(1) <= x1 & xlimit(2) >= x1 & ylimit(1) <= y1 & ylimit(2) >= y1);
   end
   xbox = xlimit([1 1 2 2 1]);
   ybox = ylimit([1 2 2 1 1]);
%    inter = zeros(x1 ,y1);
   x = x1(1,:);
   y = (y1(:,1))';
%    x_m=ones(1,length(x)) * x2;
%    y_m=ones(1,length(y)) * y2;
for k=1:col
    waitbar((k*i) /((size(coordVectors.building, 2))*col));
    for l=1:row2
        
   %[xVect, yVect] = polyxpoly([x1 x2], [y1 y2], xbox, ybox, 'unique');
        [xVect, yVect] = polyxpoly([x(k) x2], [y(l) y2], xbox, ybox, 'unique');
        numOfWalls(l,k) = numOfWalls(l,k) + size([xVect, yVect], 1);
        
       if strcmp(st1(2).file,'PLmac.m')
          dist_from_centre(l,k) = sqrt((x1(1,k)-x2)^2 + (y1(l,1)-y2)^2);
          
           if dist_from_centre(l,k) > radius_fr
                inner_point(l,k) = -0.5;
           else
                inner_point(l,k) = 0.5;
           end
          
          if (get(handles.popupmenu9,'Value') == 2)
               subscribers_partition_macro(l,k) = 1/3; %ifr
          elseif (get(handles.popupmenu9,'Value') == 3)%ffr
              if dist_from_centre(l,k) > radius_fr
                   subscribers_partition_macro(l,k) = 1/4;
               else
                   subscribers_partition_macro(l,k) = 1/4;
               end
          elseif (get(handles.popupmenu9,'Value') == 4)%sfr
               if dist_from_centre(l,k) > (radius_fr)
                   subscribers_partition_macro(l,k) = 1/3;
               else
                   subscribers_partition_macro(l,k) = 2/3;
               end
          end
          
          x_ini = x1(1,k)-x2;
          y_ini = y2 - y1(l,1);
          if inMacrocellRange(x_ini, y_ini) == 0
               subscribers_partition_macro(l,k) = 0;
               inside_of_cell_bounds(l,k) = 0;
          end
       end
       

       
%        if strcmp(st1(2).file,'PLfem.m')
%           dist_from_centre(l,k) = sqrt((x1(1,k)-250)^2 + (y1(l,1)-217)^2);
%           
%            if dist_from_centre(l,k) > radius_fr
%                 inner_point(l,k) = -0.5;
%            else
%                 inner_point(l,k) = 0.5;
%            end
%           
%           if (get(handles.popupmenu9,'Value') == 2) && (get(handles.popupmenu10,'Value') == 2)
%                subscribers_partition_femto(l,k) = 2/3; %ifr
%           elseif (get(handles.popupmenu9,'Value') == 3) && (get(handles.popupmenu10,'Value') == 2)%ffr
%               if dist_from_centre(l,k) > radius_fr
%                    subscribers_partition_femto(l,k) = 1/4;
%                else
%                    subscribers_partition_femto(l,k) = 1/4;
%                end
%           elseif (get(handles.popupmenu9,'Value') == 4)%sfr
%                if dist_from_centre(l,k) > (radius_fr)
%                    subscribers_partition_femto(l,k) = 1/3;
%                else
%                    subscribers_partition_femto(l,k) = 2/3;
%                end
%           end
%           
%           x_ini = x1(1,k)-250;
%           y_ini = 217 - y1(l,1);
%           if inMacrocellRange(x_ini, y_ini) == 0
%                subscribers_partition_femto(l,k) = 0;
%           end
%        end
    end
end
end
close(waitbar_h);
if strcmp(st1(2).file,'PLmac.m')
    coordVectors = get(handles.figure1, 'UserData');
    coordVectors.inner_point = inner_point;
    coordVectors.subscribers_partition_macro = subscribers_partition_macro;
    coordVectors.inside_of_cell_bounds = inside_of_cell_bounds;
    %coordVectors.subscribers_partition_femto = subscribers_partition_femto;
    coordVectors.dist_from_centre = dist_from_centre;
    set(handles.figure1, 'UserData', coordVectors);
end
coordVectors = get(handles.figure1, 'UserData');
phase = coordVectors.phase + 1;
coordVectors.phase = phase;

set(handles.figure1, 'UserData', coordVectors);